\section{TLS Advanced}

\subsection{Trust in a digital society}
Building trust in the online environment is the key to economic and social development. Lack of trust, in particular because of a perceived lack of legal certainty, makes consumers,  businesses
and public authorities hesitate to carry out transactions electronically and to adopt new  services. 
\subsection{Public Key Infrastructure}
\textbf{public key infrastructure (PKI)} is a set of roles, policies, hardware, software and procedures needed to create, manage, distribute, use, store and revoke digital certificates and manage public-key encryption. \\
\includegraphics[width=0.75\linewidth]{pki} \\
In order to ”secure” the http connection with TLS, public key cryptography is used for authentication, encryption and possibly digital signatures. The questions to answer are: Is this really the key for www.ost.ch? Was the key used to sign this valid at the time of signing?  The purpose of the PKI is to provide an usable answer to these questions.
\includegraphics[width=0.75\linewidth]{pkiflow}

\subsection{X.509 Certificates}
X.500 is a set of networking standards covering electronic directory services, developed by the Telecommunication Standardization Sector of the International Telecommunications Union (ITU-T), approved 1988. X.509v3 (Version 3) Profiles are the most commonly used one. They are also the one of relevance for SSL/ TLS and have been standardized by the IETF on RFC 3280 which was obsoleted in May 2008 by RFC 5280. Browser certificates shouldn't have a longer validity than 13 months. \\
\includegraphics[width=0.75\linewidth]{x.509.png}

\subsubsection{Public Key Certificate}
It is an electronic document proving the ownership of a public key.  It includes information about the key , owner (subject) and the entity that has verified the certificates content (issuer).

\subsubsection{Certificate, Certificate Extensions}
\includegraphics[width=0.75\linewidth]{x.509cert.png}\\
Certificate extensions are data fields completing the X.509 certificate. Depending on the use case of the certificate, extensions are mandatory: e.g. root CA certificate, signing certificate, TLS profile certificate, etc. \\
\includegraphics[width=0.75\linewidth]{x.509certext.png}\\
\includegraphics[width=0.75\linewidth]{x.509certextsamp.png}

\subsection{Certificate categories}
There exists four categories depending on the type of checks done during registration and the use of the TLS X.509 certificate.
\begin{description}
\item[1. Domain Validated (DV)] \hfill \\
Certificate: A Domain Validated certificate is issued after proof that the owner has the right to use their domain is established.
\item[2. Organisation Validated (OV)] \hfill \\
Certificate: For OV certificates, CAs must validate the company name, domain name and other information through the use of public databases.
\item[3. Extended Validation (EV)] \hfill \\
Certificate: EV Certificates are only issued once an entity passes a strict authentication procedure.
\item[4. Qualified Website Authentication Certificate (QWAC)] \hfill \\
A qualified website authentication certificate (QWAC certificate) is a qualified certificate under the trust services defined in the eIDAS Regulation (main current purpose is conformance to PSD2 regulation).
\end{description} 

\includegraphics[width=0.75\linewidth]{x.509add.png}

\subsection{Where to get validity information}
\begin{description}
\item[Certificate Revocation List(CRL)] \hfill \\
CRL Distribution Point included in the certificate provides the location of this CRL. 
\item[Online Certificate Status Protcol (OCSP)] \hfill \\
The Authorative Information Access (AIA) field in the certificate provides information about how to access information about a CA, such as OCSP validation and CA policy data.
\end{description}
\begin{description}
\item[Certificate Policies:] \hfill \\
This gives the link to the governance rules of the CA that are valid for a particular certificate’s usage. Each CA has
their own set of policies. 
\item[Authority Key Identifier (AKI)] \hfill \\
is the key identifier  of the Issuing CA certificate that signed the  TLS certificate. 
\item[Subject Alternative Name (SAN)] \hfill \\
various values associated with the certificate owner.
\item[Subject Key Identifier (SKI)] \hfill \\
hash value of the certificate, used to identify a certificate.
\end{description}

\subsection{Trust Service Providers - Certificate Authorities}
Does build a trust between two parties.
\subsubsection{Certificate Issuance}
The subscriber (i.e. the entity who owns the key pair whose public key should be issued a certificate to) prepares on the basis of the public key a certificate signing request (CSR). The CSR contains information on the subscriber’s object to be signed (Common Name, etc.), the public key to be signed and information on key type and length. This CSR is going to be sent to a CA in a Base64-PEM format. The CA will register the request, verify the data, and in case of positive assessment sign the CSR and turn it into a X.509 certificate.
\subsubsection{CA Hierarchy}
Root CA is the trust anchor of the PKI. Applications, computers, users that trust the Root CA trust any certificates issued by the CA hierarchy. Issuing CA issues certificates to end entities (also called Intermediate CA or Subordinate CA).
\includegraphics[width=0.75\linewidth]{cahierarchy}
\subsubsection{CA/B Browser Forum}
How does the get root CA to be accepted in the store of the browsers.  \\
\includegraphics[width=0.75\linewidth]{caforum} \\
\includegraphics[width=0.75\linewidth]{caaudit} \\
\subsubsection{Legal and Technical Requirements Set}
Legal requirements depend on national laws, for Web certificates, no special requirements in Switzerland (only additions exist for qualified signatures (ZertES law), in EU: eIDAS regulation framework. Technical requirements: ETSI TS/EN, CEN, NIST/FIPS, Browser requirements, CA/Browser requirements, Discussion Plattforms/Forums, Bugzilla, Mozilla Security Policy Group (now hosted at google).
\subsubsection{eIDAS Published Standards}
\includegraphics[width=0.75\linewidth]{eIDAS}\\
\subsubsection{Root Certificates}
Are stored in the root stores of the different companies. (CCADB - Common CA Database)
\subsubsection{Trust with Certificates}
PKI is inherently trustworthy with anything in the Trust store. If any other server pretends to be a server offering the same service, that can work as long as the client finds  the root certificate in the store. There can be a hundred of root certificates on a client machine.
\subsubsection{Certificate Pining}
Certificate pinning restricts which certificates are considered valid for a particular website,
limiting risk. Instead of allowing any trusted certificate to be used, operators “pin” the CA
issuer(s), public keys or even end-entity certificates of their choice. Clients connecting to that
server will treat all other certificates as invalid and refuse to make an HTTPS connection.
Pinning was introduced in 2011 by Google Chrome for their own issuing CA’s.  A few years later, Chrome and Firefox started allowing sites to use HTTP Public Key Pinning (HPKP). The first time your browser connects to a website using HPKP, it records the public key from the header, and will only accept that key every time it connected to the site, up until the “max-age” defined in the HPKP policy. If a max-age of 60 days was set, no other keys would be accepted for the next 60 days.\\
 Pinning models (stored in the pinset locally on the machine): Pin the root, Pin the intermediate CA, Pin the end entity certificate (also called the “ssh model”). \\
 \textbf{Risks:}  Key Compromise gets undetected (no certificate status checked). Hackers may setup a bogus HPKP on compromised servers for other purposes.
